<?php
namespace QuickBooksOnline\API\Data;

/**
 * @xmlNamespace http://schema.intuit.com/finance/v3
 * @xmlType
 * @xmlName IPPReport
 * @var IPPReport
 * @xmlDefinition Report Response Type
 */
class IPPReport
{


        /**
         * Initializes this object, optionally with pre-defined property values
         *
         * Initializes this object and it's property members, using the dictionary
         * of key/value pairs passed as an optional argument.
         *
         * @param dictionary $keyValInitializers key/value pairs to be populated into object's properties
         * @param boolean    $verbose            specifies whether object should echo warnings
         */
    public function __construct($keyValInitializers = [], $verbose = false)
    {
        foreach ($keyValInitializers as $initPropName => $initPropVal) {
            if (property_exists('IPPReport', $initPropName) || property_exists('QuickBooksOnline\API\Data\IPPReport', $initPropName)) {
                    $this->{$initPropName} = $initPropVal;
            } else {
                if ($verbose) {
                        echo "Property does not exist ($initPropName) in class (".get_class($this).')';
                }
            }
        }
    }//end __construct()

    /**
     * @Definition Report Header, contains the report options that were used to generate the report
     * @xmlType element
     * @xmlNamespace http://schema.intuit.com/finance/v3
     * @xmlMinOccurs 0
     * @xmlName Header
     * @var com\intuit\schema\finance\v3\IPPReportHeader
     */
    public $Header;

    /**
     * @Definition
     * @xmlType element
     * @xmlNamespace http://schema.intuit.com/finance/v3
     * @xmlMinOccurs 0
     * @xmlName Columns
     * @var com\intuit\schema\finance\v3\IPPColumns
     */
    public $Columns;

    /**
     * @Definition
     * @xmlType element
     * @xmlNamespace http://schema.intuit.com/finance/v3
     * @xmlMinOccurs 0
     * @xmlName Rows
     * @var com\intuit\schema\finance\v3\IPPRows
     */
    public $Rows;
}//end class

 // end class IPPReport
